// relayDlg.cpp : implementation file
// Written by Philip Allen 
// 
// Version 1.0	 2 June 2004    Initial Version
// Version 2.0	28 August 2007  Addition of Comm select dialogue box
// Version 2.1	30 August 2007  Correction for use of Com ports over 6
// Version 3.1   6 Setember 2007 Rewrite to use serial port
//

#include "stdafx.h"
#include "relay.h"
#include "relayDlg.h"
#include "CommPortSelect.h"
#include "ModuleInterface.h"
#include "serialport.h"
#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Serial port instance

	CSerialPort *port = new CSerialPort();
	CModuleInterface *ControlInterface = new CModuleInterface(port);

/////////////////////////////////////////////////////////////////////////////
// Select port Dialog instance
	CCommPortSelect selectdlg ;

// Global values 
enum {  E_SETUP = 0, E_START = 1, E_STOP = 2} eStartEvent; // state control

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRelayDlg dialog

CRelayDlg::CRelayDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRelayDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRelayDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRelayDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRelayDlg)
	DDX_Control(pDX, IDC_OPEN_RELAY, m_cmdOpenRelay);
	DDX_Control(pDX, IDC_CLEAR_RELAYS, m_cmdClearRelays);
	DDX_Control(pDX, IDC_EDIT_SET_RELAY, m_edtSetRelay);
	DDX_Control(pDX, IDC_APPLY_BTN, m_cmdApply);
	DDX_Control(pDX, IDC_COM_SELECTED, m_stcPortSelect);
	DDX_Control(pDX, IDC_RELAYS_SELECTED, m_stcNumRelays);
	DDX_Control(pDX, IDC_START_STOP, m_cmdStartStop);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRelayDlg, CDialog)
	//{{AFX_MSG_MAP(CRelayDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_APPLY_BTN, OnApplyBtn)
	ON_BN_CLICKED(IDC_CONTROL_RADIO, OnControlRadio)
	ON_BN_CLICKED(IDC_NUMBER_RADIO, OnNumberRadio)
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_PORT_COM1, OnPortCom1)
	ON_COMMAND(ID_PORT_COM2, OnPortCom2)
	ON_COMMAND(ID_PORT_COM3, OnPortCom3)
	ON_COMMAND(ID_PORT_COM4, OnPortCom4)
	ON_COMMAND(ID_PORT_COM5, OnPortCom5)
	ON_COMMAND(ID_RELAYS_16, OnRelays16)
	ON_COMMAND(ID_RELAYS_24, OnRelays24)
	ON_COMMAND(ID_RELAYS_8, OnRelays8)
	ON_COMMAND(ID_PORT_COM6, OnPortCom6)
	ON_BN_CLICKED(IDC_START_STOP, OnStartStop)
	ON_EN_CHANGE(IDC_EDIT_SET_RELAY, OnChangeEditSetRelay)
	ON_COMMAND(ID_PORT_COM_SEL, OnPortComSel)
	ON_BN_CLICKED(IDC_CHECK1, OnCheck1)
	ON_BN_CLICKED(IDC_CHECK10, OnCheck10)
	ON_BN_CLICKED(IDC_CHECK11, OnCheck11)
	ON_BN_CLICKED(IDC_CHECK12, OnCheck12)
	ON_BN_CLICKED(IDC_CHECK13, OnCheck13)
	ON_BN_CLICKED(IDC_CHECK14, OnCheck14)
	ON_BN_CLICKED(IDC_CHECK15, OnCheck15)
	ON_BN_CLICKED(IDC_CHECK16, OnCheck16)
	ON_BN_CLICKED(IDC_CHECK17, OnCheck17)
	ON_BN_CLICKED(IDC_CHECK18, OnCheck18)
	ON_BN_CLICKED(IDC_CHECK19, OnCheck19)
	ON_BN_CLICKED(IDC_CHECK2, OnCheck2)
	ON_BN_CLICKED(IDC_CHECK20, OnCheck20)
	ON_BN_CLICKED(IDC_CHECK21, OnCheck21)
	ON_BN_CLICKED(IDC_CHECK22, OnCheck22)
	ON_BN_CLICKED(IDC_CHECK23, OnCheck23)
	ON_BN_CLICKED(IDC_CHECK24, OnCheck24)
	ON_BN_CLICKED(IDC_CHECK3, OnCheck3)
	ON_BN_CLICKED(IDC_CHECK4, OnCheck4)
	ON_BN_CLICKED(IDC_CHECK5, OnCheck5)
	ON_BN_CLICKED(IDC_CHECK6, OnCheck6)
	ON_BN_CLICKED(IDC_CHECK7, OnCheck7)
	ON_BN_CLICKED(IDC_CHECK8, OnCheck8)
	ON_BN_CLICKED(IDC_CHECK9, OnCheck9)
	ON_BN_CLICKED(IDC_CLEAR_RELAYS, OnClearRelays)
	ON_BN_CLICKED(IDC_OPEN_RELAY, OnOpenRelay)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_COMMAND(ID_HELP_DEVICEMANAGER, OnHelpDevicemanager)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRelayDlg message handlers

BOOL CRelayDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	
	// Set pointers to Com port and Relay sub menu items 
	m_mainMenu = GetMenu();
	m_pmnuPort = m_mainMenu->GetSubMenu(1);
	m_pmnuRelayNum = m_mainMenu->GetSubMenu(2);


	
	mPort = 1;
	ControlInterface->CreateCommPort(mPort);
	//  Setup Control status
	SetUpControls();
	Initialise();

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRelayDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRelayDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRelayDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


int CRelayDlg::DoModal() 
{
	
	return CDialog::DoModal();
}



BEGIN_EVENTSINK_MAP(CRelayDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CRelayDlg)
	//ON_EVENT(CRelayDlg, IDC_MSCOMM1, 1 /* OnComm */, OnOnCommMscomm1, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CRelayDlg::SetUpControls(void)
{
	// Add all Relay Check Boxes to Relay Bank Array
	mRelayChk[1].SubclassDlgItem(IDC_CHECK1,this);
	mRelayChk[2].SubclassDlgItem(IDC_CHECK2,this);
	mRelayChk[3].SubclassDlgItem(IDC_CHECK3,this);
	mRelayChk[4].SubclassDlgItem(IDC_CHECK4,this);
	mRelayChk[5].SubclassDlgItem(IDC_CHECK5,this);
	mRelayChk[6].SubclassDlgItem(IDC_CHECK6,this);
	mRelayChk[7].SubclassDlgItem(IDC_CHECK7,this);
	mRelayChk[8].SubclassDlgItem(IDC_CHECK8,this);
	mRelayChk[9].SubclassDlgItem(IDC_CHECK9,this);
	mRelayChk[10].SubclassDlgItem(IDC_CHECK10,this);
	mRelayChk[11].SubclassDlgItem(IDC_CHECK11,this);
	mRelayChk[12].SubclassDlgItem(IDC_CHECK12,this);
	mRelayChk[13].SubclassDlgItem(IDC_CHECK13,this);
	mRelayChk[14].SubclassDlgItem(IDC_CHECK14,this);
	mRelayChk[15].SubclassDlgItem(IDC_CHECK15,this);
	mRelayChk[16].SubclassDlgItem(IDC_CHECK16,this);
	mRelayChk[17].SubclassDlgItem(IDC_CHECK17,this);
	mRelayChk[18].SubclassDlgItem(IDC_CHECK18,this);
	mRelayChk[19].SubclassDlgItem(IDC_CHECK19,this);
	mRelayChk[20].SubclassDlgItem(IDC_CHECK20,this);
	mRelayChk[21].SubclassDlgItem(IDC_CHECK21,this);
	mRelayChk[22].SubclassDlgItem(IDC_CHECK22,this);
	mRelayChk[23].SubclassDlgItem(IDC_CHECK23,this);
	mRelayChk[24].SubclassDlgItem(IDC_CHECK24,this);

	// define controls for Group Boxes
	mRelayBank1.SubclassDlgItem(IDC_STATIC1,this);
	mRelayBank2.SubclassDlgItem(IDC_STATIC2,this);
	mRelayBank3.SubclassDlgItem(IDC_STATIC3,this);

	// defines controls for radio buttons
	mControlRd.SubclassDlgItem(IDC_CONTROL_RADIO,this);
	mNumberRd.SubclassDlgItem(IDC_NUMBER_RADIO,this);

}

void CRelayDlg::Initialise (void)
{
	// Sets Group boxes
	mRelayBank1.EnableWindow(FALSE);
	mRelayBank2.EnableWindow(FALSE);
	mRelayBank3.EnableWindow(FALSE);

	// Sets buttons
	mControlRd.EnableWindow(FALSE);
	mNumberRd.EnableWindow(FALSE);
	// Sets up check boxes	
	for( int loop = 1; loop <= 24; loop++)
	{
		mRelayChk[loop].SetCheck(0);
		mRelayChk[loop].EnableWindow(FALSE);
	}

	//Disable Apply Button and edit box
	m_cmdApply.EnableWindow(FALSE);
	m_cmdClearRelays.EnableWindow(FALSE);
	m_cmdOpenRelay.EnableWindow(FALSE);
	m_edtSetRelay.EnableWindow(FALSE);

	// Setting of Com Port default values 
	mNumberRelaysAvailable = 0;
	mCommPortUsed = "";

	m_uApplyValue = 0;
	m_cmdStartStop.EnableWindow(FALSE);

	eStartEvent = E_SETUP;
}

void CRelayDlg::ClearSettings(void)
{
	
	// Disable all check boxes
	for(int	loop = 1; loop < 24; loop++)
	{
		mRelayChk[loop].SetCheck(0);
		mRelayChk[loop].EnableWindow(FALSE);
	}

	// Clear Text box
	SetDlgItemText(IDC_EDIT_SET_RELAY,"");
}


bool CRelayDlg::InitialiseRelays(void) 
{		
	ControlInterface->SetPortStates('B',OutputState, 0xFF);
	ControlInterface->SetPortStates('C',OutputState, 0xFF);
	ControlInterface->SetPortStates('D',OutputState, 0xFF);
	ControlInterface->ClearRelays(mNumberRelaysAvailable);
	ControlInterface->ClearRelayControls();
		
	m_cmdStartStop.EnableWindow(TRUE);
	SetDlgItemText (IDC_START_STOP,"Start");
	eStartEvent = E_START;
	return TRUE;
}



void CRelayDlg::SetControlStatus( bool state)
{
	mRelayBank1.EnableWindow(state);
	mRelayBank2.EnableWindow(FALSE);
	mRelayBank3.EnableWindow(FALSE);

	if ( mNumberRelaysAvailable > 8)
	{

		mRelayBank2.EnableWindow(state);
		
		if ( mNumberRelaysAvailable > 16)
		{
			mRelayBank3.EnableWindow(state);
		}
	}

	// Now enable/disable check buttons
	for( int loop = 1; loop <= mNumberRelaysAvailable ; loop++)
	{
		mRelayChk[loop].EnableWindow(state);
	}

	// Set apply button and Edit window to opposite of state
	m_cmdApply.EnableWindow( !state);
	m_cmdOpenRelay.EnableWindow( !state);
	//m_cmdClearRelays.EnableWindow( !state);
	m_edtSetRelay.EnableWindow( !state);

}


void CRelayDlg::CheckComSettings(int Comport)
{
	// Uncheck all Com menu items
	for (int index = 0; index < 8;  index++)
	{
		// Set uncheck against Com menu items
		// Need to check original value first
		UINT state = m_pmnuPort->GetMenuState(index, MF_BYPOSITION);
		ASSERT(state != 0xFFFFFFFF);

		if (state & MF_CHECKED)
			m_pmnuPort->CheckMenuItem(index, MF_UNCHECKED | MF_BYPOSITION);
	}

    if (Comport <= 6 )
	{
		// Set check for this Com port item
		m_pmnuPort->CheckMenuItem(Comport -1, MF_CHECKED | MF_BYPOSITION);
    }
	else
	{
		m_pmnuPort->CheckMenuItem(7, MF_CHECKED | MF_BYPOSITION);
	}

	// Set Com port to the one selected

    if (ControlInterface->SetComPortNum(Comport) == TRUE )
    {
	    ControlInterface->CreateCommPort(Comport);
    } 
    else
    {
        ClearSettings();
		mCommPortUsed = "";
        MessageBox ("Invalid Comm Port", "COMM PORT", MB_OK | MB_ICONEXCLAMATION);
    }

	// Update display
	SetDlgItemText(IDC_COM_SELECTED, mCommPortUsed);

	//If both com port and number of relays are selected enable start
	if (mCommPortUsed != ""  && mNumberRelaysAvailable != 0)
	{
		// Enable Start/Stop Button and initialse Com port
		InitialiseRelays();

	}
}

void CRelayDlg::CheckRelaySettings(int nRelay)
{
	// Clear all checks on menu items
	for (int index = 0; index < 3;  index++)
	{
		UINT state = m_pmnuRelayNum->GetMenuState(index, MF_BYPOSITION);
		ASSERT(state != 0xFFFFFFFF);
		if (state & MF_CHECKED)
			m_pmnuRelayNum->CheckMenuItem(index, MF_UNCHECKED | MF_BYPOSITION);
	}
	// Set check for this Com port item
	m_pmnuRelayNum->CheckMenuItem(nRelay, MF_CHECKED | MF_BYPOSITION);

	// Update display
	mNumberRelaysAvailable  = (nRelay + 1) * 8;

	// Convert string from text box to int 
	char sRelays[4];
	sprintf(sRelays,"%d" ,mNumberRelaysAvailable);

	//Update display
	SetDlgItemText(IDC_RELAYS_SELECTED, sRelays);

	//If both com port and number of relays are selected enable start
	if (mCommPortUsed != ""  && mNumberRelaysAvailable != 0)
	{
		// Enable Start/Stop Button and initialse relays
		InitialiseRelays();
	}

}

void CRelayDlg::OperateRelay (int RelayNum)
{
	if ( mNumberRelaysAvailable >= RelayNum)
	{
		if(mRelayChk[RelayNum].GetCheck() == TRUE)
		{
			// sends commands to relay module 
			ControlInterface->CloseRelay(RelayNum);
		}
		else
		{
			ControlInterface->OpenRelay(RelayNum);
		}
	}
}

void CRelayDlg::OnStartStop() 
{
	// Determines which state button was left in 
	// and sets controls as required
	switch (eStartEvent)
	{

		case E_START:
		mControlRd.EnableWindow(TRUE);
		mNumberRd.EnableWindow(TRUE);
		m_mainMenu->EnableMenuItem(1, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
		m_mainMenu->EnableMenuItem(2, MF_BYPOSITION | MF_DISABLED | MF_GRAYED);
		m_cmdClearRelays.EnableWindow(TRUE);

		SetDlgItemText (IDC_START_STOP,"Stop");
		eStartEvent = E_STOP;
		break;

	case E_STOP:
		SetControlStatus(FALSE);

		mControlRd.EnableWindow(FALSE);
		mNumberRd.EnableWindow(FALSE);
		mControlRd.SetCheck(FALSE);
		mNumberRd.SetCheck(FALSE);

		m_cmdApply.EnableWindow( FALSE);
		m_cmdClearRelays.EnableWindow(TRUE);
		m_cmdOpenRelay.EnableWindow(FALSE);
		m_edtSetRelay.EnableWindow( FALSE);

		ClearSettings();

		m_mainMenu->EnableMenuItem(1, MF_BYPOSITION | MF_ENABLED);
		m_mainMenu->EnableMenuItem(2, MF_BYPOSITION | MF_ENABLED);

		SetDlgItemText (IDC_START_STOP,"Start");
		eStartEvent = E_START;
		break;
	}
	
}

void CRelayDlg::OnApplyBtn() 
{
	// Controls the setting of an individual relay
	int RelayValue;
	char lsRelayVal[5];
	CString ButtonText;

	// Gets value in Edit box and converts to int
	int NumLines = m_edtSetRelay.GetLine(0, lsRelayVal,4);
	RelayValue = atoi(lsRelayVal);
	
	// Check if value is in valid range
	if (RelayValue >= 1 && RelayValue <= mNumberRelaysAvailable)
	{
		ControlInterface->CloseRelay(RelayValue );
	}

}


void CRelayDlg::OnControlRadio() 
{

	bool state;

	if ( mControlRd.GetCheck() == TRUE )
	{
		mNumberRd.SetCheck(FALSE);
		state = TRUE;
		ClearSettings();
	}
	else
	{
		mNumberRd.SetCheck(TRUE);
		state = FALSE;
	}

	SetControlStatus(state);
}


void CRelayDlg::OnNumberRadio() 
{
	bool state;
	ClearSettings();

	if ( mNumberRd.GetCheck() == TRUE )
	{
		mControlRd.SetCheck(FALSE);
		state = FALSE;
	}
	else
	{
		mControlRd.SetCheck(TRUE);
		state = TRUE;
	}
	
	SetControlStatus(state);
	
}


void CRelayDlg::OnFileExit() 
{
		CDialog::OnCancel();
	
}


void CRelayDlg::OnPortCom1() 
{

	int mnuStrLen = m_pmnuPort->GetMenuString(0, mCommPortUsed, MF_BYPOSITION);

	// Clear all checks on menu items and display
	CheckComSettings(1);
}


void CRelayDlg::OnPortCom2() 
{
	int mnuStrLen = m_pmnuPort->GetMenuString(1, mCommPortUsed, MF_BYPOSITION);

	// Clear all checks on menu items and display
	CheckComSettings(2);

}

void CRelayDlg::OnPortCom3() 
{
	int mnuStrLen = m_pmnuPort->GetMenuString(2, mCommPortUsed, MF_BYPOSITION);

	// Clear all checks on menu items and display
	CheckComSettings(3);
	
}

void CRelayDlg::OnPortCom4() 
{
	int mnuStrLen = m_pmnuPort->GetMenuString(3, mCommPortUsed, MF_BYPOSITION);

	// Clear all checks on menu items and display
	CheckComSettings(4);

}

void CRelayDlg::OnPortCom5() 
{
	int mnuStrLen = m_pmnuPort->GetMenuString(4, mCommPortUsed, MF_BYPOSITION);

	// Clear all checks on menu items and display
	CheckComSettings(5);
	
}


void CRelayDlg::OnPortCom6() 
{
	int mnuStrLen = m_pmnuPort->GetMenuString(5, mCommPortUsed, MF_BYPOSITION);

	// Clear all checks on menu items and display
	CheckComSettings(6);
	
}


void CRelayDlg::OnPortComSel() 
{
	int PortNum;
	CString dummyString;
    char buffer [10];

	int nResponse = selectdlg.DoModal();

	if (nResponse == IDOK)
	{
		//  Code here to handle when the dialog is
		//  dismissed with OK
		PortNum = selectdlg.PortValue();
		sprintf(buffer,"Com%d", PortNum);
		mCommPortUsed = buffer;

		CheckComSettings(PortNum);// Check port expects 1 less than real port num
	}
	else if (nResponse == IDCANCEL)
	{

	}
}


void CRelayDlg::OnRelays8() 
{
	
	CString l_sNumRelays;

	int mnuStrLen = m_pmnuRelayNum->GetMenuString(0, l_sNumRelays, MF_BYPOSITION);

	CheckRelaySettings(0);

}


void CRelayDlg::OnRelays16() 
{
	CString l_sNumRelays;

	int mnuStrLen = m_pmnuRelayNum->GetMenuString(1, l_sNumRelays, MF_BYPOSITION);

	CheckRelaySettings(1);

}


void CRelayDlg::OnRelays24() 
{

	CString l_sNumRelays;

	int mnuStrLen = m_pmnuRelayNum->GetMenuString(2, l_sNumRelays, MF_BYPOSITION);

	CheckRelaySettings(2);
	
}


void CRelayDlg::OnChangeEditSetRelay() 
{
	// Allows for message when return is pressed in edit box
}

/* End of file */


void CRelayDlg::OnCheck1() 
{
	OperateRelay (1);
}

void CRelayDlg::OnCheck2() 
{
	OperateRelay (2);	
}

void CRelayDlg::OnCheck3() 
{
	OperateRelay (3);	
}

void CRelayDlg::OnCheck4() 
{
	OperateRelay (4);	
}

void CRelayDlg::OnCheck5() 
{
	OperateRelay (5);	
}

void CRelayDlg::OnCheck6() 
{
	OperateRelay (6);	
}

void CRelayDlg::OnCheck7() 
{
	OperateRelay (7);	
}

void CRelayDlg::OnCheck8() 
{
	OperateRelay (8);	
}

void CRelayDlg::OnCheck9() 
{
	if ( mNumberRelaysAvailable >= 9)
		OperateRelay (9);	
}
void CRelayDlg::OnCheck10() 
{
	if ( mNumberRelaysAvailable >= 10)
		OperateRelay (10);	
}

void CRelayDlg::OnCheck11() 
{
	if ( mNumberRelaysAvailable >= 11)
		OperateRelay (11);	
}

void CRelayDlg::OnCheck12() 
{
	if ( mNumberRelaysAvailable >= 12)
		OperateRelay (12);	
}

void CRelayDlg::OnCheck13() 
{
	if ( mNumberRelaysAvailable >= 13)
		OperateRelay (13);	
}

void CRelayDlg::OnCheck14() 
{
	if ( mNumberRelaysAvailable >= 14)
		OperateRelay (14);	
}

void CRelayDlg::OnCheck15() 
{
	if ( mNumberRelaysAvailable >= 15)
		OperateRelay (15);	
}

void CRelayDlg::OnCheck16() 
{
	if ( mNumberRelaysAvailable >= 16)
		OperateRelay (16);	
}

void CRelayDlg::OnCheck17() 
{
	if ( mNumberRelaysAvailable >= 17)
		OperateRelay (17);	
}

void CRelayDlg::OnCheck18() 
{
	if ( mNumberRelaysAvailable >= 18)
		OperateRelay (18);	
}

void CRelayDlg::OnCheck19() 
{
	if ( mNumberRelaysAvailable >= 19)
		OperateRelay (19);	
}

void CRelayDlg::OnCheck20() 
{
	if ( mNumberRelaysAvailable >= 20)
		OperateRelay (20);	
}

void CRelayDlg::OnCheck21() 
{
	if ( mNumberRelaysAvailable >= 21)
		OperateRelay (21);	
}

void CRelayDlg::OnCheck22() 
{
	if ( mNumberRelaysAvailable >= 22)
		OperateRelay (22);	
}

void CRelayDlg::OnCheck23() 
{
	if ( mNumberRelaysAvailable >= 23)
		OperateRelay (23);	
}

void CRelayDlg::OnCheck24() 
{
	if ( mNumberRelaysAvailable >= 24)
		OperateRelay (24);	
}


void CRelayDlg::OnClearRelays() 
{
	ControlInterface->ClearRelays(24);
		for(int	loop = 1; loop <= 24; loop++)
	{
		mRelayChk[loop].SetCheck(0);
	}

	// Clear Text box
	SetDlgItemText(IDC_EDIT_SET_RELAY,"");
}

void CRelayDlg::OnOpenRelay() 
{
	// Controls the setting of an individual relay
	int RelayValue;
	char lsRelayVal[5];
	CString ButtonText;

	// Gets value in Edit box and converts to int
	int NumLines = m_edtSetRelay.GetLine(0, lsRelayVal,4);
	RelayValue = atoi(lsRelayVal);
	
	// Check if value is in valid range
	if (RelayValue >= 1 && RelayValue <= mNumberRelaysAvailable)
	{
		ControlInterface->OpenRelay(RelayValue );
	}
}

void CRelayDlg::OnHelpAbout() 
{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
}

void CRelayDlg::OnHelpDevicemanager() 
{
	int response = system("C://WINDOWS//system32//mmc.exe C://WINDOWS//system32//devmgmt.msc //s");	
}
